/******************************************************************************
*                                                                             *
*    mxcalc.c                                    Copyright(c) 2007 itow,y.    *
*                                                                             *
******************************************************************************/


#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <shlobj.h>
#include <tchar.h>
#include "resource.h"
#include "calclib.h"


/* EBhENX */
#define CALC_MAIN_CLASS TEXT("mxcalc class")
/* ^Cg */
#define TITLE_TEXT TEXT("mxcalc")

/* Rg[ID */
#define IDC_COMBOBOX	200
#define IDC_CLEAR		201
#define IDC_MENU		202
#define IDC_CLOSE		203

/* gCACR瑗郁bZ[W */
#define TRAY_ICON_MESSAGE WM_USER

/* ͂ł鎮̍ő咷(null܂) */
#define MAX_EXPRESSION 256

#define CAPTION_WIDTH	14	/* LvV̕ */
#define CAPTION_MARGIN	2	/* LvVƃR{{bNX̊Ԃ̗] */


static HINSTANCE hInst;						/* CX^Xnh */
static HWND hwndMain;						/* CEBhE */
static HWND hwndComboBox;					/* R{{bNX */
static HWND hwndEdit;						/* R{{bNX̃GfBbg */
static WNDPROC pfnOldEditProc;				/* GfBbǧ̃vV[W */
static HWND hwndClear;						/* NA{^ */
static HWND hwndMenu;						/* j[{^ */
static HWND hwndClose;						/* {^ */

static TCHAR szIniFileName[MAX_PATH];		/* INIt@C */

static int nWindowXPos=0;					/* EBhE̍ʒu */
static int nWindowYPos=0;					/* EBhȄʒu */
static int nWindowWidth=200;				/* EBhE̕ */
static int nMinWindowWidth;					/* EBhE̍ŏ */
static int nWindowHeight;					/* EBhE̍ */
static HBITMAP hbmClear;					/* NA[{^̃rbg}bv */
static HBITMAP hbmMenu;						/* j[{^̃rbg}bv */
static HBITMAP hbmClose;					/* {^̃rbg}bv */
static BOOL fAlwaysOnTop=FALSE;				/* ɑOʂɕ\ */
static BOOL fTranslucent=FALSE;				/* \ */
static int nHexBits=32;						/* 16/2i̐x */

static TCHAR szExpBuffer[MAX_EXPRESSION];	/* vZpobt@ */
static BOOL fEditNow=FALSE;					/* ύXtO */

/* \p */
static HINSTANCE hUser32Lib=NULL;
typedef BOOL (WINAPI *SetLayeredWindowAttributesFunc)(
													HWND,COLORREF,BYTE,DWORD);
static SetLayeredWindowAttributesFunc pfnSetLayeredWindowAttributes=NULL;

static BOOL fResident=FALSE;					/* 풓 */
static BOOL fUseHotKey=FALSE;					/* zbgL[L */
static UINT uHotKey=MAKEWORD('C',HOTKEYF_CONTROL | HOTKEYF_ALT);
static BOOL fKeepSingleInstance=TRUE;			/* NȂ */
#define MAX_HISTORY 100							/* ̍ő吔̍ő */
static int nMaxHistory=10;						/* ̍ő吔 */
static BOOL fSaveHistory=TRUE;					/* ۑ */
static BOOL fUseCustomColors=TRUE;				/* zFw */
static COLORREF crTextColor=RGB(255,255,255);	/* F */
static COLORREF crBackColor=RGB(0,0,0);			/* wiF */
static HBRUSH hbrBackground=NULL;				/* wiuV */
static LOGFONT lfTextFont;						/* tHg */
static HFONT hfontText;							/* tHg̃nh */
#define MIN_OPACITY 20							/* sx̍ŏ */
#define MAX_OPACITY 99							/* sx̍ő */
static int nOpacity=70;							/* sx */




/*
	FIp_CAO\
*/
static BOOL ChooseColorDialog(HWND hwndOwner,COLORREF *pcr)
{
	static COLORREF crCustomColors[16] = {
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF)
	};
	CHOOSECOLOR cc;

	cc.lStructSize=sizeof(CHOOSECOLOR);
	cc.hwndOwner=hwndOwner;
	cc.rgbResult=*pcr;
	cc.lpCustColors=crCustomColors;
	cc.Flags=CC_RGBINIT;
	if (!ChooseColor(&cc))
		return FALSE;
	*pcr=cc.rgbResult;
	return TRUE;
}


/*
	tHgI_CAO\
*/
static BOOL ChooseFontDialog(HWND hwndOwner,LOGFONT *plf)
{
	CHOOSEFONT cf;

	cf.lStructSize=sizeof(CHOOSEFONT);
	cf.hwndOwner=hwndOwner;
	cf.lpLogFont=plf;
	cf.Flags=CF_FORCEFONTEXIST | CF_INITTOLOGFONTSTRUCT | CF_SCREENFONTS;
	return ChooseFont(&cf);
}


/*
	t@CύX
*/
static LPTSTR ChangeFileName(LPTSTR pszFilePath,LPCTSTR pszFileName)
{
	LPTSTR p,q;

	p=q=pszFilePath;
	while (*p!='\0') {
#ifndef UNICODE
		if (IsDBCSLeadByteEx(CP_ACP,*p)) {
			p+=2;
			continue;
		}
#endif
		if (*p++=='\\')
			q=p;
	}
	lstrcpy(q,pszFileName);
	return pszFilePath;
}


/*
	EBhEtHAOEhɐݒ肷
*/
static void MySetForegroundWindow(HWND hwnd)
{
	OSVERSIONINFO osvi;

	osvi.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
	GetVersionEx(&osvi);
	if ((osvi.dwPlatformId==VER_PLATFORM_WIN32_WINDOWS
												&& osvi.dwMinorVersion>=10)
			|| (osvi.dwPlatformId==VER_PLATFORM_WIN32_NT
												&& osvi.dwMajorVersion>=5)) {
		int nTargetID,nForegroundID;

		nForegroundID=GetWindowThreadProcessId(GetForegroundWindow(),NULL);
		nTargetID=GetWindowThreadProcessId(hwnd,NULL);
		AttachThreadInput(nTargetID,nForegroundID,TRUE);
		SetForegroundWindow(hwnd);
		AttachThreadInput(nTargetID,nForegroundID,FALSE);
	} else
		SetForegroundWindow(hwnd);
}


/*
	ݒ̓ǂݍ
*/
static BOOL ReadPref(void)
{
	TCHAR szText[LF_FACESIZE];

	nWindowXPos=GetPrivateProfileInt(TEXT("Settings"),TEXT("WindowLeft"),
													nWindowXPos,szIniFileName);
	nWindowYPos=GetPrivateProfileInt(TEXT("Settings"),TEXT("WindowTop"),
													nWindowYPos,szIniFileName);
	nWindowWidth=GetPrivateProfileInt(TEXT("Settings"),TEXT("WindowWidth"),
												nWindowWidth,szIniFileName);
	fAlwaysOnTop=GetPrivateProfileInt(TEXT("Settings"),TEXT("AlwaysOnTop"),
												fAlwaysOnTop,szIniFileName)!=0;
	fTranslucent=GetPrivateProfileInt(TEXT("Settings"),TEXT("Translucent"),
												fTranslucent,szIniFileName)!=0;
	nHexBits=GetPrivateProfileInt(TEXT("Settings"),TEXT("HexBits"),nHexBits,
																szIniFileName);
	if (nHexBits!=32 && nHexBits!=64) {
		if (nHexBits<32)
			nHexBits=32;
		else
			nHexBits=64;
	}
	fResident=GetPrivateProfileInt(TEXT("Settings"),TEXT("Resident"),fResident,
															szIniFileName)!=0;
	fUseHotKey=GetPrivateProfileInt(TEXT("Settings"),TEXT("UseHotKey"),
												fUseHotKey,szIniFileName)!=0;
	uHotKey=GetPrivateProfileInt(TEXT("Settings"),TEXT("HotKey"),uHotKey,
																szIniFileName);
	fKeepSingleInstance=GetPrivateProfileInt(TEXT("Settings"),
				TEXT("SingleInstance"),fKeepSingleInstance,szIniFileName)!=0;
	nMaxHistory=GetPrivateProfileInt(TEXT("Settings"),TEXT("MaxHistory"),
													nMaxHistory,szIniFileName);
	if (nMaxHistory<1)
		nMaxHistory=1;
	else if (nMaxHistory>MAX_HISTORY)
		nMaxHistory=MAX_HISTORY;
	fSaveHistory=GetPrivateProfileInt(TEXT("Settings"),TEXT("SaveHistory"),
												fSaveHistory,szIniFileName)!=0;
	crTextColor=GetPrivateProfileInt(TEXT("Settings"),TEXT("TextColor"),
													crTextColor,szIniFileName);
	crBackColor=GetPrivateProfileInt(TEXT("Settings"),TEXT("BackColor"),
													crBackColor,szIniFileName);
	if (GetPrivateProfileString(TEXT("Settings"),TEXT("FontName"),TEXT(""),
										szText,LF_FACESIZE,szIniFileName)>0) {
		lstrcpy(lfTextFont.lfFaceName,szText);
		lfTextFont.lfEscapement=0;
		lfTextFont.lfOrientation=0;
		lfTextFont.lfUnderline=0;
		lfTextFont.lfStrikeOut=0;
		lfTextFont.lfCharSet=DEFAULT_CHARSET;
		lfTextFont.lfOutPrecision=OUT_DEFAULT_PRECIS;
		lfTextFont.lfClipPrecision=CLIP_DEFAULT_PRECIS;
		lfTextFont.lfQuality=DRAFT_QUALITY;
		lfTextFont.lfPitchAndFamily=DEFAULT_PITCH | FF_DONTCARE;
	}
	lfTextFont.lfHeight=GetPrivateProfileInt(TEXT("Settings"),TEXT("FontSize"),
											lfTextFont.lfHeight,szIniFileName);
	lfTextFont.lfWidth=0;
	lfTextFont.lfWeight=GetPrivateProfileInt(TEXT("Settings"),TEXT("FontBold"),
			lfTextFont.lfWeight==FW_BOLD,szIniFileName)!=0?FW_BOLD:FW_NORMAL;
	lfTextFont.lfItalic=GetPrivateProfileInt(TEXT("Settings"),
						TEXT("FontItalic"),lfTextFont.lfItalic,szIniFileName);
	nOpacity=GetPrivateProfileInt(TEXT("Settings"),TEXT("Opacity"),nOpacity,
																szIniFileName);
	if (nOpacity<MIN_OPACITY)
		nOpacity=MIN_OPACITY;
	else if (nOpacity>MAX_OPACITY)
		nOpacity=MAX_OPACITY;
	return TRUE;
}


/*
	̓ǂݍ
*/
static BOOL ReadHistory(void)
{
	int nCount;

	nCount=GetPrivateProfileInt(TEXT("History"),TEXT("Count"),0,szIniFileName);
	if (nCount>0) {
		int i;
		TCHAR szKey[8];

		if (nCount>nMaxHistory)
			nCount=nMaxHistory;
		for (i=0;i<nCount;i++) {
			wsprintf(szKey,TEXT("%d"),i);
			if (GetPrivateProfileString(TEXT("History"),szKey,TEXT(""),
								szExpBuffer,MAX_EXPRESSION,szIniFileName)>0)
				(void)ComboBox_AddString(hwndComboBox,szExpBuffer);
		}
	}
	return TRUE;
}


/*
	INIt@Cintl
*/
static BOOL WritePrivateProfileInt(LPCTSTR pszSection,LPCTSTR pszKey,
												int nValue,LPCTSTR pszFile)
{
	TCHAR szValue[16];

	wsprintf(szValue,TEXT("%d"),nValue);
	return WritePrivateProfileString(pszSection,pszKey,szValue,pszFile);
}


/*
	ݒ̕ۑ
*/
static BOOL WritePref(void)
{
	WINDOWPLACEMENT wc;
	int nCount;
	TCHAR szText[16];

	wc.length=sizeof(WINDOWPLACEMENT);
	GetWindowPlacement(hwndMain,&wc);
	nWindowXPos=wc.rcNormalPosition.left;
	nWindowYPos=wc.rcNormalPosition.top;
	nWindowWidth=wc.rcNormalPosition.right-wc.rcNormalPosition.left;
	WritePrivateProfileInt(TEXT("Settings"),TEXT("WindowLeft"),nWindowXPos,
																szIniFileName);
	WritePrivateProfileInt(TEXT("Settings"),TEXT("WindowTop"),nWindowYPos,
																szIniFileName);
	WritePrivateProfileInt(TEXT("Settings"),TEXT("WindowWidth"),nWindowWidth,
																szIniFileName);
	WritePrivateProfileInt(TEXT("Settings"),TEXT("AlwaysOnTop"),fAlwaysOnTop,
																szIniFileName);
	WritePrivateProfileInt(TEXT("Settings"),TEXT("Translucent"),fTranslucent,
																szIniFileName);
	WritePrivateProfileInt(TEXT("Settings"),TEXT("HexBits"),nHexBits,
																szIniFileName);
	WritePrivateProfileInt(TEXT("Settings"),TEXT("Resident"),fResident,
																szIniFileName);
	WritePrivateProfileInt(TEXT("Settings"),TEXT("UseHotKey"),fUseHotKey,
																szIniFileName);
	WritePrivateProfileInt(TEXT("Settings"),TEXT("HotKey"),uHotKey,
																szIniFileName);
	WritePrivateProfileInt(TEXT("Settings"),TEXT("SingleInstance"),
											fKeepSingleInstance,szIniFileName);
	WritePrivateProfileInt(TEXT("Settings"),TEXT("MaxHistory"),nMaxHistory,
																szIniFileName);
	WritePrivateProfileInt(TEXT("Settings"),TEXT("SaveHistory"),fSaveHistory,
																szIniFileName);
	WritePrivateProfileInt(TEXT("Settings"),TEXT("TextColor"),crTextColor,
																szIniFileName);
	WritePrivateProfileInt(TEXT("Settings"),TEXT("BackColor"),crBackColor,
																szIniFileName);
	WritePrivateProfileString(TEXT("Settings"),TEXT("FontName"),
										lfTextFont.lfFaceName,szIniFileName);
	WritePrivateProfileInt(TEXT("Settings"),TEXT("FontSize"),
											lfTextFont.lfHeight,szIniFileName);
	WritePrivateProfileInt(TEXT("Settings"),TEXT("FontBold"),
								lfTextFont.lfWeight==FW_BOLD,szIniFileName);
	WritePrivateProfileInt(TEXT("Settings"),TEXT("FontItalic"),
										lfTextFont.lfItalic!=0,szIniFileName);
	WritePrivateProfileInt(TEXT("Settings"),TEXT("Opacity"),nOpacity,
																szIniFileName);
	if (fSaveHistory)
		nCount=ComboBox_GetCount(hwndComboBox);
	else
		nCount=0;
	wsprintf(szText,TEXT("Count=%d%c"),nCount,'\0');
	if (WritePrivateProfileSection(TEXT("History"),szText,szIniFileName)
																&& nCount>0) {
		int i;

		for (i=0;i<nCount;i++) {
			(void)ComboBox_GetLBText(hwndComboBox,i,szExpBuffer);
			wsprintf(szText,TEXT("%d"),i);
			WritePrivateProfileString(TEXT("History"),szText,szExpBuffer,
																szIniFileName);
		}
	}
	return TRUE;
}


/*
	zbgL[ݒ肷
*/
static BOOL SetHotKey(WORD wKey)
{
	if (wKey!=0) {
		BYTE bFlags=HIBYTE(wKey);
		BYTE bMod;

		bMod=0;
		if ((bFlags&HOTKEYF_ALT)!=0)
			bMod|=MOD_ALT;
		if ((bFlags&HOTKEYF_CONTROL)!=0)
			bMod|=MOD_CONTROL;
		if ((bFlags&HOTKEYF_SHIFT)!=0)
			bMod|=MOD_SHIFT;
		if ((bFlags&HOTKEYF_EXT)!=0)
			bMod|=MOD_WIN;
		if (!RegisterHotKey(hwndMain,0,bMod,LOBYTE(wKey))) {
			MessageBox(hwndMain,TEXT("zbgL[ݒł܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
			return FALSE;
		}
	} else
		UnregisterHotKey(hwndMain,0);
	return TRUE;
}


/*
	^XNgCɃACRǉ
*/
static BOOL AddTrayIcon(HWND hwnd)
{
	NOTIFYICONDATA nid;

	nid.cbSize=sizeof(NOTIFYICONDATA);
	nid.hWnd=hwnd;
	nid.uID=1;
	nid.uFlags=NIF_MESSAGE | NIF_ICON | NIF_TIP;
	nid.uCallbackMessage=TRAY_ICON_MESSAGE;
	nid.hIcon=LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON));
	lstrcpy(nid.szTip,TITLE_TEXT);
	return Shell_NotifyIcon(NIM_ADD,&nid);
}


/*
	^XNgC̃ACR폜
*/
static BOOL DeleteTrayIcon(HWND hwnd)
{
	NOTIFYICONDATA nid;

	nid.cbSize=sizeof(NOTIFYICONDATA);
	nid.hWnd=hwnd;
	nid.uID=1;
	nid.uFlags=0;
	return Shell_NotifyIcon(NIM_DELETE,&nid);
}


/*
	CEBhE̍vZ
*/
static int CalcMainWindowHeight(void)
{
	HDC hdc;
	HFONT hfontOld;
	TEXTMETRIC tm;
	RECT rc;

	hdc=GetDC(hwndComboBox);
	hfontOld=(HFONT)SelectObject(hdc,hfontText);
	GetTextMetrics(hdc,&tm);
	SelectObject(hdc,hfontOld);
	ReleaseDC(hwndComboBox,hdc);
	rc.left=rc.top=0;
	rc.right=100;
	rc.bottom=tm.tmHeight+2+GetSystemMetrics(SM_CYEDGE)*2;
	AdjustWindowRectEx(&rc,GetWindowStyle(hwndMain),FALSE,
												GetWindowExStyle(hwndMain));
	return rc.bottom-rc.top;
}


/*
	tHg̏ݒ肷
*/
static void SetFontInfo(HWND hDlg,const LOGFONT *plf)
{
	HDC hdc;
	HFONT hfont,hfontOld;
	TEXTMETRIC tm;
	TCHAR szText[LF_FACESIZE+16];

	hdc=GetDC(hwndEdit);
	if (hdc==NULL)
		return;
	hfont=CreateFontIndirect(plf);
	if (hfont==NULL) {
		ReleaseDC(hwndEdit,hdc);
		return;
	}
	hfontOld=(HFONT)SelectObject(hdc,hfont);
	GetTextMetrics(hdc,&tm);
	wsprintf(szText,TEXT("%s,%d"),plf->lfFaceName,
		(tm.tmHeight-tm.tmInternalLeading)*72/GetDeviceCaps(hdc,LOGPIXELSY));
	SetDlgItemText(hDlg,IDC_PREF_FONT_INFO,szText);
	SelectObject(hdc,hfontOld);
	DeleteObject(hfont);
	ReleaseDC(hwndEdit,hdc);
}


/*
	sx̕ݒ肷
*/
static void SetOpacityText(HWND hDlg)
{
	TCHAR szText[6];

	wsprintf(szText,TEXT("%d %%"),
					SendDlgItemMessage(hDlg,IDC_PREF_TRANS_TB,TBM_GETPOS,0,0));
	SetDlgItemText(hDlg,IDC_PREF_TRANS_TEXT,szText);
}


/*
	_CAÕACe̗L/ݒ肷
*/
static void EnableDlgItems(HWND hDlg,int nFirstID,int nLastID,BOOL fEnable)
{
	int i;

	for (i=nFirstID;i<=nLastID;i++)
		EnableWindow(GetDlgItem(hDlg,i),fEnable);
}


/*
	ݒ_CAOvV[W
*/
BOOL CALLBACK PrefDlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	static COLORREF crText,crBack;
	static LOGFONT lfText;
	static BOOL fFontChanged;

	switch (uMsg) {
	case WM_INITDIALOG:
		CheckDlgButton(hDlg,IDC_PREF_RESIDENT,
										fResident?BST_CHECKED:BST_UNCHECKED);
		CheckDlgButton(hDlg,IDC_PREF_USEHOTKEY,
										fUseHotKey?BST_CHECKED:BST_UNCHECKED);
		EnableWindow(GetDlgItem(hDlg,IDC_PREF_HOTKEY),fUseHotKey);
		SendDlgItemMessage(hDlg,IDC_PREF_HOTKEY,HKM_SETRULES,
										HKCOMB_NONE,MAKELPARAM(HOTKEYF_ALT,0));
		SendDlgItemMessage(hDlg,IDC_PREF_HOTKEY,HKM_SETHOTKEY,uHotKey,0);
		CheckDlgButton(hDlg,IDC_PREF_SINGLEINSTANCE,
								fKeepSingleInstance?BST_CHECKED:BST_UNCHECKED);
		SetDlgItemInt(hDlg,IDC_PREF_MAXHISTORY,nMaxHistory,TRUE);
		SendDlgItemMessage(hDlg,IDC_PREF_MAXHISTORY_UD,UDM_SETRANGE,0,
													MAKELPARAM(MAX_HISTORY,1));
		EnableWindow(GetDlgItem(hDlg,IDC_PREF_CLEARHISTORY),
											ComboBox_GetCount(hwndComboBox)>0);
		CheckDlgButton(hDlg,IDC_PREF_SAVEHISTORY,
									fSaveHistory?BST_CHECKED:BST_UNCHECKED);
		CheckDlgButton(hDlg,IDC_PREF_USECUSTOMCOLORS,
								fUseCustomColors?BST_CHECKED:BST_UNCHECKED);
		EnableDlgItems(hDlg,IDC_PREF_TEXTCOLOR_LABEL,IDC_PREF_BACKCOLOR_CHOOSE,
															fUseCustomColors);
		crText=crTextColor;
		crBack=crBackColor;
		lfText=lfTextFont;
		fFontChanged=FALSE;
		SetFontInfo(hDlg,&lfText);
		SendDlgItemMessage(hDlg,IDC_PREF_TRANS_TB,TBM_SETRANGE,TRUE,
										MAKELPARAM(MIN_OPACITY,MAX_OPACITY));
		SendDlgItemMessage(hDlg,IDC_PREF_TRANS_TB,TBM_SETPOS,TRUE,nOpacity);
		SendDlgItemMessage(hDlg,IDC_PREF_TRANS_TB,TBM_SETPAGESIZE,0,10);
		SendDlgItemMessage(hDlg,IDC_PREF_TRANS_TB,TBM_SETTICFREQ,10,0);
		SetOpacityText(hDlg);
		EnableDlgItems(hDlg,IDC_PREF_TRANS_GROUP,IDC_PREF_TRANS_TEXT,
										pfnSetLayeredWindowAttributes!=NULL);
		return TRUE;

	case WM_DRAWITEM:
		{
			LPDRAWITEMSTRUCT pdis=(LPDRAWITEMSTRUCT)lParam;
			COLORREF cr;
			HBRUSH hbr;

			if (wParam==IDC_PREF_TEXTCOLOR_SAMPLE)
				cr=crText;
			else
				cr=crBack;
			hbr=CreateSolidBrush(cr);
			FillRect(pdis->hDC,&pdis->rcItem,hbr);
			DeleteObject(hbr);
		}
		return TRUE;

	case WM_HSCROLL:
		SetOpacityText(hDlg);
		return TRUE;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_PREF_USEHOTKEY:
			EnableWindow(GetDlgItem(hDlg,IDC_PREF_HOTKEY),
					IsDlgButtonChecked(hDlg,IDC_PREF_USEHOTKEY)==BST_CHECKED);
			return TRUE;
		case IDC_PREF_CLEARHISTORY:
			(void)ComboBox_ResetContent(hwndComboBox);
			EnableWindow(GetDlgItem(hDlg,IDC_PREF_CLEARHISTORY),FALSE);
			return TRUE;
		case IDC_PREF_USECUSTOMCOLORS:
			EnableDlgItems(hDlg,IDC_PREF_TEXTCOLOR_LABEL,
													IDC_PREF_BACKCOLOR_CHOOSE,
				IsDlgButtonChecked(hDlg,IDC_PREF_USECUSTOMCOLORS)==
																BST_CHECKED);
			return TRUE;
		case IDC_PREF_TEXTCOLOR_CHOOSE:
			if (ChooseColorDialog(hDlg,&crText))
				InvalidateRect(GetDlgItem(hDlg,IDC_PREF_TEXTCOLOR_SAMPLE),
																	NULL,TRUE);
			return TRUE;
		case IDC_PREF_BACKCOLOR_CHOOSE:
			if (ChooseColorDialog(hDlg,&crBack))
				InvalidateRect(GetDlgItem(hDlg,IDC_PREF_BACKCOLOR_SAMPLE),
																	NULL,TRUE);
			return TRUE;
		case IDC_PREF_FONT_CHOOSE:
			if (ChooseFontDialog(hDlg,&lfText)) {
				SetFontInfo(hDlg,&lfText);
				fFontChanged=TRUE;
			}
			return TRUE;
		case IDOK:
			{
				BOOL f;
				UINT uKey;

				f=IsDlgButtonChecked(hDlg,IDC_PREF_RESIDENT)==BST_CHECKED;
				if (f!=fResident) {
					if (f)
						AddTrayIcon(hwndMain);
					else
						DeleteTrayIcon(hwndMain);
					fResident=f;
				}
				f=IsDlgButtonChecked(hDlg,IDC_PREF_USEHOTKEY)==BST_CHECKED;
				uKey=(WORD)SendDlgItemMessage(hDlg,IDC_PREF_HOTKEY,
															HKM_GETHOTKEY,0,0);
				if (f!=fUseHotKey || (f && uKey!=uHotKey)) {
					if (f) {
						fUseHotKey=SetHotKey(uKey);
					} else {
						SetHotKey(0);
						fUseHotKey=FALSE;
					}
				}
				uHotKey=uKey;
				fKeepSingleInstance=IsDlgButtonChecked(hDlg,
										IDC_PREF_SINGLEINSTANCE)==BST_CHECKED;
				nMaxHistory=GetDlgItemInt(hDlg,IDC_PREF_MAXHISTORY,NULL,TRUE);
				if (nMaxHistory<1)
					nMaxHistory=1;
				else if (nMaxHistory>MAX_HISTORY)
					nMaxHistory=MAX_HISTORY;
				if (ComboBox_GetCount(hwndComboBox)>nMaxHistory) {
					int i;

					for (i=ComboBox_GetCount(hwndComboBox)-1;i>=nMaxHistory;
																		i--)
						(void)ComboBox_DeleteString(hwndComboBox,i);
				}
				fSaveHistory=IsDlgButtonChecked(hDlg,IDC_PREF_SAVEHISTORY)==
																BST_CHECKED;
				fUseCustomColors=IsDlgButtonChecked(hDlg,
										IDC_PREF_USECUSTOMCOLORS)==BST_CHECKED;
				if (fUseCustomColors) {
					if (crBack!=crBackColor || hbrBackground==NULL) {
						if (hbrBackground!=NULL)
							DeleteObject(hbrBackground);
						hbrBackground=CreateSolidBrush(crBack);
					}
				} else if (hbrBackground!=NULL) {
					DeleteObject(hbrBackground);
					hbrBackground=NULL;
				}
				crTextColor=crText;
				crBackColor=crBack;
				if (fFontChanged) {
					RECT rc;

					lfTextFont=lfText;
					DeleteObject(hfontText);
					hfontText=CreateFontIndirect(&lfTextFont);
					SetWindowFont(hwndComboBox,hfontText,FALSE);
					GetWindowRect(hwndMain,&rc);
					nWindowHeight=CalcMainWindowHeight();
					MoveWindow(hwndMain,rc.left,rc.top,
										rc.right-rc.left,nWindowHeight,TRUE);
				}
				InvalidateRect(hwndComboBox,NULL,TRUE);
				if (pfnSetLayeredWindowAttributes!=NULL) {
					int i;

					i=SendDlgItemMessage(hDlg,IDC_PREF_TRANS_TB,TBM_GETPOS,
																		0,0);
					if (fTranslucent && i!=nOpacity)
						(*pfnSetLayeredWindowAttributes)(hwndMain,0,i*255/100,
																	LWA_ALPHA);
					nOpacity=i;
				}
			}
		case IDCANCEL:
			EndDialog(hDlg,LOWORD(wParam));
			return TRUE;
		}
	}
	return FALSE;
}


/*
	o[W_CAOvV[W
*/
BOOL CALLBACK AboutDlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam )
{
	static HFONT hfontLink;

	switch (uMsg) {
	case WM_INITDIALOG:
		{
			LOGFONT lf;

			GetObject((HFONT)SendMessage(hDlg,WM_GETFONT,0,0),
														sizeof(LOGFONT),&lf);
			lf.lfUnderline=1;
			hfontLink=CreateFontIndirect(&lf);
			SendDlgItemMessage(hDlg,IDC_ABOUT_WEB,WM_SETFONT,
													(WPARAM)hfontLink,FALSE);
		}
		return TRUE;

	case WM_CTLCOLORSTATIC:
		if ((HWND)lParam==GetDlgItem(hDlg,IDC_ABOUT_WEB)) {
			SetTextColor((HDC)wParam,RGB(0,0,255));
			SetBkMode((HDC)wParam,TRANSPARENT);
			return (BOOL)(HBRUSH)GetStockObject(NULL_BRUSH);
		}
		break;

	case WM_SETCURSOR:
		if ((HWND)wParam==GetDlgItem(hDlg,IDC_ABOUT_WEB)) {
			SetCursor(LoadCursor(NULL,IDC_HAND));
			SetWindowLongPtr(hDlg,DWLP_MSGRESULT,TRUE);
			return TRUE;
		}
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_ABOUT_WEB:
			if (HIWORD(wParam)==STN_CLICKED)
				ShellExecute(NULL,TEXT("open"),
							TEXT("http://www.geocities.jp/iooiau/"),NULL,NULL,
																SW_SHOWNORMAL);
			return TRUE;
		case IDOK:
		case IDCANCEL:
			EndDialog(hDlg,LOWORD(wParam));
		}
		return TRUE;

	case WM_DESTROY:
		DeleteObject(hfontLink);
		return TRUE;
	}
	return FALSE;
}


/*
	vZ擾
*/
static int GetEditText(void)
{
	int nLength;

	nLength=ComboBox_GetTextLength(hwndComboBox);
	if (nLength<1)
		return 0;
	ComboBox_GetText(hwndComboBox,szExpBuffer,MAX_EXPRESSION);
	return nLength;
}


/*
	vZ̎s
*/
static BOOL DoCalc(void)
{
	LPTSTR p;
	int nBase;
	clError Err;
	clValue Answer;
	clChar szBuff[72];
	DWORD dwSel;

	if (GetEditText()<2)
		return FALSE;
	p=szExpBuffer;
	while (*p!='\0') {
		if (*p=='=')
			break;
		p++;
	}
	if (*p=='\0' || p==szExpBuffer)
		return FALSE;
	*p='\0';
	if (*(p+1)=='$' || *(p+1)=='x' || *(p+1)=='X') {
		nBase=16;
		p++;
	} else if (*(p+1)=='b' || *(p+1)=='B') {
		nBase=2;
		p++;
	} else
		nBase=10;
	Err=clCalc(szExpBuffer,&Answer);
	if (Err==CL_ERR_OK) {
		switch (nBase) {
		case 10:
			Err=clFloatToDec(Answer,szBuff);
			break;
		case 16:
			Err=clFloatToHex(Answer,szBuff,nHexBits);
			break;
		case 2:
			Err=clFloatToBin(Answer,szBuff,nHexBits);
			break;
		}
	}
	if (Err!=CL_ERR_OK)
		lstrcpy(szBuff,TEXT("?"));
	fEditNow=TRUE;
	dwSel=Edit_GetSel(hwndEdit);
	Edit_SetSel(hwndEdit,p-szExpBuffer+1,-1);
	Edit_ReplaceSel(hwndEdit,szBuff);
	Edit_SetSel(hwndEdit,LOWORD(dwSel),HIWORD(dwSel));
	fEditNow=FALSE;
	return Err==CL_ERR_OK;
}


/*
	GfBbgRg[̃tbNvV[W
*/
LRESULT CALLBACK EditSubClassProc(HWND hwnd,UINT uMsg,WPARAM wParam,
																LPARAM lParam)
{
	switch (uMsg) {
	case WM_KEYDOWN:
		if (wParam==VK_RETURN) {
			if (GetEditText()>0) {
				LPTSTR p;

				p=szExpBuffer;
				while (*p!='=') {
					if (*p=='\0') {
						fEditNow=TRUE;
						Edit_SetSel(hwnd,p-szExpBuffer,-1);
						Edit_ReplaceSel(hwnd,TEXT("="));
						fEditNow=FALSE;
						break;
					}
					p++;
				}
				if (p==szExpBuffer)
					return 0;
				if (DoCalc()) {
					// ɒǉ
					int i;

					ComboBox_GetText(hwndComboBox,szExpBuffer,MAX_EXPRESSION);
					i=ComboBox_FindStringExact(hwndComboBox,-1,szExpBuffer);
					if (i==CB_ERR) {
						(void)ComboBox_InsertString(hwndComboBox,0,
																szExpBuffer);
						if (ComboBox_GetCount(hwndComboBox)>nMaxHistory)
							(void)ComboBox_DeleteString(hwndComboBox,
																nMaxHistory);
					} else if (i!=0) {
						(void)ComboBox_DeleteString(hwndComboBox,i);
						(void)ComboBox_InsertString(hwndComboBox,0,
																szExpBuffer);
					}
				}
			}
			return 0;
		}
		break;

	case WM_CHAR:
		{
#ifndef UNICODE
			static BOOL fDBChar=FALSE;

			if (fDBChar) {
				fDBChar=FALSE;
				return 0;
			}
#endif
			if (!IsCharAlphaNumeric(wParam)) {
				switch (wParam) {
				case '\b':
				case '.':
				case '+':
				case '-':
				case '*':
				case '/':
				case '\\':
				case '%':
				case '=':
				case '(':
				case ')':
				case ':':
				case '$':
				case '^':
					break;
				case '\r':
				case '\n':
					return 0;
				default:
#ifndef UNICODE
					if (IsDBCSLeadByteEx(CP_ACP,wParam))
						fDBChar=TRUE;
#endif
					MessageBeep(0xFFFFFFFF);
					return 0;
				}
			}
		}
		break;
	}
	return CallWindowProc(pfnOldEditProc,hwnd,uMsg,wParam,lParam);
}


/*
	NA{^̃rbg}bvݒ肷
*/
static void SetClearButtonBitmap(void)
{
	hbmClear=(HBITMAP)LoadImage(hInst,MAKEINTRESOURCE(IDB_CLEAR),IMAGE_BITMAP,
									0,0,LR_DEFAULTSIZE | LR_LOADMAP3DCOLORS);
	SendMessage(hwndClear,BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)hbmClear);
}


/*
	j[{^̃rbg}bvݒ肷
*/
static void SetMenuButtonBitmap(void)
{
	hbmMenu=(HBITMAP)LoadImage(hInst,MAKEINTRESOURCE(IDB_MENU),IMAGE_BITMAP,
									0,0,LR_DEFAULTSIZE | LR_LOADMAP3DCOLORS);
	SendMessage(hwndMenu,BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)hbmMenu);
}


/*
	{^̃rbg}bvݒ肷
*/
static void SetCloseButtonBitmap(void)
{
	hbmClose=(HBITMAP)LoadImage(hInst,MAKEINTRESOURCE(IDB_CLOSE),IMAGE_BITMAP,
									0,0,LR_DEFAULTSIZE | LR_LOADMAP3DCOLORS);
	SendMessage(hwndClose,BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)hbmClose);
}


#ifdef __BORLANDC__
#pragma argsused
#endif
static BOOL OnCreate(HWND hwnd,LPCREATESTRUCT pcs)
{
	hfontText=CreateFontIndirect(&lfTextFont);
	if (fUseCustomColors)
		hbrBackground=CreateSolidBrush(crBackColor);

	/* R{{bNX̍쐬 */
	hwndComboBox=CreateWindowEx(0,TEXT("COMBOBOX"),NULL,
		WS_CHILD | WS_VISIBLE | WS_BORDER | WS_VSCROLL | WS_CLIPSIBLINGS |
												CBS_DROPDOWN | CBS_AUTOHSCROLL,
								0,0,0,0,hwnd,(HMENU)IDC_COMBOBOX,hInst,NULL);
	(void)ComboBox_LimitText(hwndComboBox,MAX_EXPRESSION-1);
	hwndEdit=GetTopWindow(hwndComboBox);
	pfnOldEditProc=(WNDPROC)SetWindowLongPtr(hwndEdit,GWLP_WNDPROC,
												(LONG_PTR)EditSubClassProc);
	SetWindowFont(hwndComboBox,hfontText,FALSE);

	/* {^̍쐬 */
	hwndClear=CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),
		WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | BS_PUSHBUTTON | BS_BITMAP,
									0,0,0,0,hwnd,(HMENU)IDC_CLEAR,hInst,NULL);
	SetClearButtonBitmap();
	hwndMenu=CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),
		WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | BS_PUSHBUTTON | BS_BITMAP,
									0,0,0,0,hwnd,(HMENU)IDC_MENU,hInst,NULL);
	SetMenuButtonBitmap();
	hwndClose=CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),
		WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | BS_PUSHBUTTON | BS_BITMAP,
									0,0,0,0,hwnd,(HMENU)IDC_CLOSE,hInst,NULL);
	SetCloseButtonBitmap();

	/* ^XNgCɒǉ */
	if (fResident)
		AddTrayIcon(hwnd);
	return TRUE;
}


#ifdef __BORLANDC__
#pragma argsused
#endif
static void OnSize(HWND hwnd,UINT state,int cx,int cy)
{
	MoveWindow(hwndComboBox,CAPTION_WIDTH+CAPTION_MARGIN,0,
							cx-(CAPTION_WIDTH+CAPTION_MARGIN)-cy*3,cy+64,TRUE);
	MoveWindow(hwndClear,cx-cy*3,0,cy,cy,TRUE);
	MoveWindow(hwndMenu,cx-cy*2,0,cy,cy,TRUE);
	MoveWindow(hwndClose,cx-cy,0,cy,cy,TRUE);
}


static void OnGetMinMaxInfo(HWND hwnd,LPMINMAXINFO pmmi)
{
	RECT rc;

	/* EBhE̍ύXłȂ */
	pmmi->ptMinTrackSize.y=nWindowHeight;
	pmmi->ptMaxTrackSize.y=nWindowHeight;
	/* ŏ̕w肷 */
	GetClientRect(hwnd,&rc);
	pmmi->ptMinTrackSize.x=nMinWindowWidth;
}


#ifdef __BORLANDC__
#pragma argsused
#endif
static void OnCommand(HWND hwnd,int id,HWND hwndCtl,UINT codeNotify)
{
	switch (id) {
	case IDC_COMBOBOX:
		if (codeNotify==CBN_EDITCHANGE && !fEditNow)
			DoCalc();
		break;

	case IDC_CLEAR:
	case CM_CLEAR:
		ComboBox_SetText(hwndComboBox,TEXT(""));
		SetFocus(hwndComboBox);
		break;

	case IDC_MENU:
		{
			HMENU hmenu;
			RECT rc;

			hmenu=LoadMenu(hInst,MAKEINTRESOURCE(IDM_MAIN));
			CheckMenuItem(hmenu,CM_ALWAYSONTOP,
					MF_BYCOMMAND | (fAlwaysOnTop?MFS_CHECKED:MFS_UNCHECKED));
			EnableMenuItem(hmenu,CM_TRANSLUCENT,MF_BYCOMMAND |
				(pfnSetLayeredWindowAttributes!=NULL?MFS_ENABLED:MFS_GRAYED));
			if (pfnSetLayeredWindowAttributes!=NULL)
				CheckMenuItem(hmenu,CM_TRANSLUCENT,
					MF_BYCOMMAND | (fTranslucent?MFS_CHECKED:MFS_UNCHECKED));
			CheckMenuRadioItem(hmenu,CM_DWORD,CM_QWORD,
								nHexBits==32?CM_DWORD:CM_QWORD,MF_BYCOMMAND);
			GetWindowRect(hwndMenu,&rc);
			TrackPopupMenu(GetSubMenu(hmenu,0),TPM_LEFTBUTTON,
												rc.left,rc.bottom,0,hwnd,NULL);
			DestroyMenu(hmenu);
		}
		break;

	case CM_CUT:
		SendMessage(hwndEdit,WM_CUT,0,0);
		break;

	case CM_COPY:
		SendMessage(hwndEdit,WM_COPY,0,0);
		break;

	case CM_PASTE:
		SendMessage(hwndEdit,WM_PASTE,0,0);
		break;

	case CM_DELETE:
		SendMessage(hwndEdit,WM_CLEAR,0,0);
		break;

	case CM_SELECTALL:
		(void)ComboBox_SetEditSel(hwndComboBox,0,-1);
		break;

	case CM_ALWAYSONTOP:
		fAlwaysOnTop=!fAlwaysOnTop;
		SetWindowPos(hwnd,fAlwaysOnTop?HWND_TOPMOST:HWND_NOTOPMOST,
											0,0,0,0,SWP_NOMOVE | SWP_NOSIZE);
		break;

	case CM_TRANSLUCENT:
		if (pfnSetLayeredWindowAttributes!=NULL) {
			fTranslucent=!fTranslucent;
			SetWindowLong(hwnd,GWL_EXSTYLE,
										GetWindowExStyle(hwnd)^WS_EX_LAYERED);
			if (fTranslucent)
				(*pfnSetLayeredWindowAttributes)(hwnd,0,nOpacity*255/100,
																	LWA_ALPHA);
		}
		break;

	case CM_DWORD:
	case CM_QWORD:
		if (id==CM_DWORD)
			nHexBits=32;
		else
			nHexBits=64;
		if (GetEditText()>3) {
			LPTSTR p;

			p=szExpBuffer;
			while (*p!='\0') {
				if (*p=='=')
					break;
				p++;
			}
			if (*p=='=' && (*(p+1)=='$' || *(p+1)=='x' || *(p+1)=='X'
												|| *(p+1)=='b' || *(p+1)=='B'))
				DoCalc();
		}
		break;

	case CM_PREFERENCES:
		DialogBox(hInst,MAKEINTRESOURCE(IDD_PREFERENCES),hwnd,PrefDlgProc);
		break;

	case CM_ABOUT:
		DialogBox(hInst,MAKEINTRESOURCE(IDD_ABOUT),hwnd,AboutDlgProc);
		break;

	case CM_EXIT:
		DestroyWindow(hwnd);
		break;

	case CM_CLOSE:
	case IDC_CLOSE:
		SendMessage(hwnd,WM_CLOSE,0,0);
		break;

	case CM_SHOW:
		if (!IsWindowVisible(hwndMain))
			ShowWindow(hwndMain,SW_SHOW);
		if (IsIconic(hwndMain))
			ShowWindow(hwndMain,SW_RESTORE);
		MySetForegroundWindow(hwndMain);
		break;
	}
}


LRESULT CALLBACK MainWndProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{

	switch (uMsg) {
		HANDLE_MSG(hwnd,WM_CREATE,OnCreate);

	case WM_CTLCOLOREDIT:
	case WM_CTLCOLORLISTBOX:
		if (fUseCustomColors) {
			SetTextColor((HDC)wParam,crTextColor);
			SetBkColor((HDC)wParam,crBackColor);
			return (LRESULT)hbrBackground;
		}
		break;

	case WM_SETFOCUS:
		SetFocus(hwndComboBox);
		return 0;

		HANDLE_MSG(hwnd,WM_SIZE,OnSize);
		HANDLE_MSG(hwnd,WM_GETMINMAXINFO,OnGetMinMaxInfo);

	case WM_PAINT:
		{
			PAINTSTRUCT ps;

			BeginPaint(hwnd,&ps);
			if (ps.rcPaint.left<CAPTION_WIDTH) {
				HBRUSH hbr;
				RECT rc;

				hbr=CreateSolidBrush(GetSysColor(GetForegroundWindow()==hwnd?
								COLOR_ACTIVECAPTION:COLOR_INACTIVECAPTION));
				rc.left=ps.rcPaint.left;
				rc.top=ps.rcPaint.top;
				rc.right=min(ps.rcPaint.right,CAPTION_WIDTH);
				rc.bottom=ps.rcPaint.bottom;
				FillRect(ps.hdc,&rc,hbr);
				DeleteObject(hbr);
			}
			EndPaint(hwnd,&ps);
		}
		return 0;

	case WM_NCACTIVATE:
		InvalidateRect(hwnd,NULL,TRUE);
		break;

	case WM_NCHITTEST:
		{
			int nCode;

			nCode=DefWindowProc(hwnd,uMsg,wParam,lParam);
			if (nCode==HTCLIENT)
				nCode=HTCAPTION;
			return nCode;
		}

	case WM_SETCURSOR:
		switch (LOWORD(lParam)) {
		case HTTOP:
		case HTBOTTOM:
			SetCursor(LoadCursor(NULL,IDC_ARROW));
			return TRUE;
		case HTTOPLEFT:
		case HTTOPRIGHT:
		case HTBOTTOMLEFT:
		case HTBOTTOMRIGHT:
			SetCursor(LoadCursor(NULL,IDC_SIZEWE));
			return TRUE;
		}
		break;

	case WM_NCRBUTTONDOWN:
		if (wParam==HTCAPTION) {
			POINTS pt=MAKEPOINTS(lParam);
			HMENU hmenu;

			hmenu=LoadMenu(hInst,MAKEINTRESOURCE(IDM_CAPTION));
			TrackPopupMenu(GetSubMenu(hmenu,0),TPM_RIGHTBUTTON,pt.x,pt.y,0,
																	hwnd,NULL);
			DestroyMenu(hmenu);
		}
		return 0;

	case WM_SYSCOLORCHANGE:
		DeleteObject(hbmClear);
		SetClearButtonBitmap();
		DeleteObject(hbmMenu);
		SetMenuButtonBitmap();
		DeleteObject(hbmClose);
		SetCloseButtonBitmap();
		return 0;

	case TRAY_ICON_MESSAGE:
		switch (lParam) {
		case WM_LBUTTONDOWN:
			SendMessage(hwnd,WM_COMMAND,MAKEWPARAM(CM_SHOW,0),0);
			return 0;
		case WM_RBUTTONDOWN:
			{
				HMENU hmenu;
				POINT pt;

				hmenu=LoadMenu(hInst,MAKEINTRESOURCE(IDM_TRAY));
				GetCursorPos(&pt);
				TrackPopupMenu(GetSubMenu(hmenu,0),TPM_RIGHTBUTTON,pt.x,pt.y,0,
																	hwnd,NULL);
				DestroyMenu(hmenu);
			}
			return 0;
		}
		return 0;

	case WM_HOTKEY:
		SendMessage(hwnd,WM_COMMAND,MAKEWPARAM(CM_SHOW,0),0);
		return 0;

		HANDLE_MSG(hwnd,WM_COMMAND,OnCommand);

	case WM_CLOSE:
		if (fResident) {
			ShowWindow(hwnd,SW_HIDE);
			return 0;
		}
		break;

	case WM_DESTROY:
		if (hbrBackground!=NULL)
			DeleteObject(hbrBackground);
		DeleteObject(hfontText);
		DeleteObject(hbmClear);
		DeleteObject(hbmMenu);
		DeleteObject(hbmClose);
		if (fResident)
			DeleteTrayIcon(hwnd);
		WritePref();
		PostQuitMessage(0);
		return 0;
	}
	return DefWindowProc(hwnd,uMsg,wParam,lParam);
}


#ifdef __BORLANDC__
#pragma argsused
#endif
int APIENTRY _tWinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,
												LPTSTR pszCmdLine,int nCmdShow)
{
	HACCEL haccel;
	MSG msg;

	/* ϐ̏ */
	hInst=hInstance;
	GetObject(GetStockObject(DEFAULT_GUI_FONT),sizeof(LOGFONT),&lfTextFont);

	/* ݒ̓ǂݍ */
	GetModuleFileName(hInst,szIniFileName,MAX_PATH);
	ChangeFileName(szIniFileName,TEXT("mxcalc.ini"));
	ReadPref();

	/* NȂ悤ɂ */
	if (fKeepSingleInstance) {
		HWND hwnd=FindWindow(CALC_MAIN_CLASS,NULL);

		if (hwnd!=NULL) {
			SendMessage(hwnd,WM_COMMAND,MAKEWPARAM(CM_SHOW,0),0);
			return 0;
		}
	}

	/* EBhENX̓o^ */
	{
		WNDCLASS wc;

		wc.style=0;
		wc.lpfnWndProc=MainWndProc;
		wc.cbClsExtra=0;
		wc.cbWndExtra=0;
		wc.hInstance=hInst;
		wc.hIcon=LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON));
		wc.hCursor=LoadCursor(NULL,IDC_ARROW);
		wc.hbrBackground=(HBRUSH)(COLOR_3DFACE+1);
		wc.lpszMenuName=NULL;
		wc.lpszClassName=CALC_MAIN_CLASS;
		if (RegisterClass(&wc)==0) {
			MessageBox(NULL,TEXT("EBhENXo^ł܂B"),NULL,
														MB_OK | MB_ICONSTOP);
			return 0;
		}
	}

	/* RRg[̏ */
	{
		INITCOMMONCONTROLSEX icc;

		icc.dwSize=sizeof(INITCOMMONCONTROLSEX);
		icc.dwICC=ICC_BAR_CLASSES | ICC_HOTKEY_CLASS;
		InitCommonControlsEx(&icc);
	}

	/* SetLayeredWindowAttributes()̃AhX擾 */
	hUser32Lib=(HINSTANCE)LoadLibrary(TEXT("USER32.DLL"));
	if (hUser32Lib!=NULL)
		pfnSetLayeredWindowAttributes=(SetLayeredWindowAttributesFunc)
					GetProcAddress(hUser32Lib,"SetLayeredWindowAttributes");
	if (pfnSetLayeredWindowAttributes==NULL)
		fTranslucent=FALSE;

	/* EBhE̍쐬 */
	{
		DWORD dwExStyle;

		dwExStyle=0;
		if (fAlwaysOnTop)
			dwExStyle|=WS_EX_TOPMOST;
		if (fTranslucent)
			dwExStyle|=WS_EX_LAYERED;
		hwndMain=CreateWindowEx(dwExStyle,CALC_MAIN_CLASS,TITLE_TEXT,
							WS_POPUP | WS_THICKFRAME | WS_CLIPCHILDREN,
							nWindowXPos,nWindowYPos,0,0,NULL,NULL,hInst,NULL);
		if (hwndMain==NULL) {
			MessageBox(NULL,TEXT("EBhE쐬ł܂B"),NULL,
														MB_OK | MB_ICONSTOP);
			return 0;
		}
	}
	{
		RECT rc;

		GetClientRect(hwndMain,&rc);
		nMinWindowWidth=CAPTION_WIDTH+CAPTION_MARGIN+32+rc.bottom*3+
												GetSystemMetrics(SM_CXFRAME)*2;
	}
	if (nWindowWidth<nMinWindowWidth)
		nWindowWidth=nMinWindowWidth;
	nWindowHeight=CalcMainWindowHeight();
	SetWindowPos(hwndMain,NULL,0,0,nWindowWidth,nWindowHeight,
													SWP_NOMOVE | SWP_NOZORDER);
	if (fTranslucent)
		(*pfnSetLayeredWindowAttributes)(hwndMain,0,nOpacity*255/100,
																	LWA_ALPHA);
	ShowWindow(hwndMain,nCmdShow);
	UpdateWindow(hwndMain);

	/* ̓ǂݍ */
	ReadHistory();

	/* zbgL[̓o^ */
	if (fUseHotKey)
		SetHotKey(uHotKey);

	/* ANZ[^e[u̓ǂݍ */
	haccel=LoadAccelerators(hInst,MAKEINTRESOURCE(IDA_ACCEL));

	/* bZ[W[v */
	while (GetMessage(&msg,NULL,0,0)) {
		if(!TranslateAccelerator(hwndMain,haccel,&msg)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	if (hUser32Lib!=NULL)
		FreeLibrary(hUser32Lib);

	return msg.wParam;
}
